	list p=p16f628
	#include <P16f628.inc>
	errorlevel -302
	__CONFIG _WDT_OFF & _PWRTE_ON &_LVP_OFF & _BODEN_OFF & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT
;**************** ************
ADR_FLH	EQU	20H		;   FLACH
ADR_FLL	EQU	21H
A_FLH_C	EQU	22H
A_FLL_C	EQU	23H

REG0	EQU	24H
REG1	EQU	25H
REG2	EQU	26H		;{
REG3	EQU	27H		;  
REG4	EQU	28H		;
REG5	EQU	29H		;}
REG6	EQU	2AH

TEMP	EQU	2BH		;{
TEMP2	EQU	2CH		; 
COUNT	EQU	2DH		; 
COUNT2	EQU	2EH		;}
COUNT3	EQU	2FH


ADR_EEP	EQU	30H		;   EEPROM

NFAT_H	EQU	31H
NFAT_L	EQU	32H

A_H_H	EQU	33H
A_H_L	EQU	34H
A_L_H	EQU	35H
A_L_L	EQU	36H

DAT	EQU	37H	;   
ROD	EQU	38H	;  ROOT DIRECTORI
FAT	EQU	39H	;  FAT

SIZE_H	EQU	3AH
SIZE_L	EQU	3BH

NSEK	EQU	3CH	; 
SEK_C_H	EQU	3DH	;  
SEK_C_L	EQU	3EH

REG7	EQU	3FH
REG8	EQU	40H
REG9	EQU	41H
REG10	EQU	42H
REG11	EQU	43H
REG12	EQU	44H

PFAT_H	EQU	45H	;  
PFAT_L	EQU	46H	;

OPT	EQU	47H	; 

AVT_2	EQU	48H	; 
AVT_1	EQU	49H
AVT_0	EQU	4AH

CSEK	EQU	4BH	;     
CSEK_H	EQU	4CH

KL_E_H	EQU	4DH	;  
KL_E_L	EQU	4EH

REG13	EQU	4FH
REG14	EQU	50H
REG15	EQU	51H

;EQU	6FH		; 



;******MultiMediaCard
;portb
CS	equ	3		;Chip Select
SCK	equ	1		; 
DatO	equ	0		;   
DatI	equ	2		;   



;*******LCD 
;portb
SCLK	EQU	4
SDTA	EQU	5
DORC	EQU	7
ENAB	EQU	6		;Chip Select(CS)


;*******FLASH
;porta
SDA	EQU	3		;sda_flash
SCL	EQU	2		;scl_flash



;*******
;porta
KEY1	EQU	1		;0 - 
KEY2	EQU	0		;1 - 
KEY3	EQU	7		;* - 
KEY4	EQU	6		;# - 




;*****************  ************************
BEGIN:	BCF	STATUS,RP1
	BCF	STATUS,RP0	;  0
        CLRF	PORTB		;  portb
        MOVLW	B'11110000'	; 
        BSF	STATUS,RP0	;  1
        MOVWF	TRISB		
	BSF	TRISB,DatO
;****************  ***********************
	BCF	STATUS,RP0
	movlw	H'07'
	movwf	CMCON		; PortA  /
	CLRF	PORTA
	MOVLW	B'11111111'
	BSF	STATUS,RP0
	MOVWF	TRISA		
	BCF	STATUS,RP0

;*********   *******
	BSF	PORTB,CS
	BSF	PORTB,SCK
	BSF	PORTB,DatI

	MOVLW	D'10'		;RESET
	MOVWF	REG4
RE1:	CALL	SPI_F
	DECFSZ	REG4,F
	GOTO	RE1

	BCF	PORTB,CS

	CALL	SPI_F		;CMD0
	MOVLW	H'40'
	CALL	SPI
	MOVLW	H'00'
	CALL	SPI
	MOVLW	H'00'
	CALL	SPI
	MOVLW	H'00'
	CALL	SPI
	MOVLW	H'00'
	CALL	SPI
	MOVLW	H'95'		;CRC
	CALL	SPI
	CALL	SPI_F
	CALL	SPI_F		;RESPONSE
	
;************   

	MOVLW	D'200'
	MOVWF	REG4
C1:	MOVLW	H'00'		;CMD1
	MOVWF	A_H_H
	MOVWF	A_H_L
	MOVWF	A_L_H
	MOVWF	A_L_L
	MOVLW	H'41'
	CALL	COMM
	MOVWF	TEMP2
	DECF	REG4,F		;  
	BTFSC	STATUS,Z
	BCF	TEMP2,0
	BTFSC	TEMP2,0
	GOTO	C1


	MOVLW	D'00'	;FAT=0 (00:00)		;  16 
	MOVWF	FAT
	MOVLW	D'32'	;ROD=8192 (32:00)
	MOVWF	ROD
	MOVLW	D'48'	;DAT=12288 (48:00)
	MOVWF	DAT

;	MOVLW	D'00'	;FAT=0 (00:00)		;  32 
;	MOVWF	FAT
;	MOVLW	D'62'	;ROD=15872 (62:00)
;	MOVWF	ROD
;	MOVLW	D'78'	;DAT=19968 (78:00)
;	MOVWF	DAT



;	MOVLW	D'00'	;FAT=0 (00:00)		;  64 
;	MOVWF	FAT
;	MOVLW	D'122'	;ROD=31232 (122:00)
;	MOVWF	ROD
;	MOVLW	D'138'	;DAT=35328 (138:00)
;	MOVWF	DAT

	BSF	PORTB,CS
	CALL	SPI_F


;**************************  
LB3:	BTFSS	PORTA,KEY4
	GOTO	LB3
	BTFSC	PORTA,KEY3
	GOTO	LB3

	MOVLW	0FFH
	MOVWF	REG3
	MOVLW	070H
	MOVWF	REG2
LB4:	BTFSC	PORTA,KEY3	
	GOTO	LB3	
	BTFSC	PORTA,KEY4
	GOTO	LB3
	DECFSZ	REG3,1
	GOTO	LB4
	MOVLW	D'50'			;25 ms
	CALL	PAUSE_M
	DECFSZ	REG2,1
	GOTO	LB4

	BSF	STATUS,RP0		;  LCD
	BCF	STATUS,RP1
	BCF	TRISB,SCLK
	BCF	STATUS,RP0
	BCF	PORTB,SDTA
	CALL	CON
	MOVLW	20H			;H=0
	CALL	LCD_C
	CALL	LCD_R
	MOVLW	B'01000010'		;
	CALL	LCD_C
	MOVLW	B'10001100'
	CALL	LCD_C
	CALL	N_CON

	BCF	STATUS,RP1		; Flash-
	BSF	STATUS,RP0
	BCF	TRISA,SDA
	BCF	TRISA,SCL
	BCF	STATUS,RP0
	BSF	PORTA,SDA

	MOVLW	D'10'			;
	MOVWF	REG5
ZS:	MOVF	REG5,W
	SUBLW	D'10'
	CALL	TABL
	CALL	SMB
	DECFSZ	REG5,F
	GOTO	ZS


LB5:	MOVLW	D'25'		;  
	CALL	PAUSE_MK
	BTFSS	PORTA,KEY3
	GOTO	LB5



	MOVLW	H'7F'		;  
	MOVWF	ADR_EEP
	CALL	READ_EE
	MOVWF	OPT

	BCF	PORTB,CS
	CALL	SPI_F

	CLRF	AVT_0		; 
	CLRF	AVT_1
	MOVF	OPT,W
	ANDLW	B'00001111'
	MOVWF	AVT_2
	INCF	AVT_2,F

	BTFSS	OPT,6		;
	GOTO	AVS
	CALL	CON
	MOVLW	B'00001101'
	CALL	LCD_C
	CALL	N_CON

AVS:	MOVLW	H'00'
	CALL	READ_FILE
	CALL	MMC_READ
	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
	GOTO	P_KEY1



;***************************************************************
;***************      ******************************
;***************************************************************
LABEL:	BTFSS	PORTA,KEY1
	GOTO	P_KEY1
	BTFSS	PORTA,KEY2
	GOTO	P_KEY2
	BTFSS	PORTA,KEY3
	GOTO	P_KEY3
	BTFSS	PORTA,KEY4
	GOTO	P_KEY4

	BTFSS	OPT,7
	GOTO	LABEL
	INCF	AVT_0,F
	BTFSC	STATUS,Z
	INCF	AVT_1,F
	BTFSS	STATUS,Z
	GOTO	LABEL
	DECF	AVT_2,F
	BTFSS	STATUS,Z
	GOTO	LABEL

	CLRF	AVT_0
	CLRF	AVT_1
	MOVF	OPT,W
	ANDLW	B'00001111'
	MOVWF	AVT_2
	INCF	AVT_2,F

;*********************
;****** 
;*********************
P_KEY1:	MOVLW	D'200'		
	CALL	PAUSE_MK
	BTFSS	PORTA,KEY1
	GOTO	P_KEY1

	BTFSC	OPT,5		;  
	GOTO	OBRAB

	MOVLW	H'A0'		;  
	MOVWF	FSR
	MOVLW	D'78'
	MOVWF	REG9
KFL:	CALL	MMC_BYTE
	MOVWF	INDF
	INCF	FSR,F
	DECFSZ	REG9,F
	GOTO	KFL

	CALL	WRITE_VRAM

	GOTO	LABEL

OBRAB:
				;  
	MOVLW	H'A0'
	MOVWF	REG10		; VRAM
	MOVLW	H'70'
	MOVWF	REG11		; 
	CLRF	REG12


	MOVLW	D'06'
	MOVWF	REG9
JK1_1:	MOVLW	D'13'
	MOVWF	REG8

JK:	CALL	MMC_BYTE	
	MOVWF	REG6
	SUBLW	H'20'
	BTFSS	STATUS,Z	;   
	GOTO	P_K102

	MOVF	REG12,F		;  
	BTFSS	STATUS,Z
	GOTO	JK

	DECF	REG12,F
	MOVLW	H'20'
	CALL	WRT_C
	MOVF	REG9,F
	BTFSC	STATUS,Z
	GOTO	JK_V
	GOTO	JK		



P_K102:	MOVLW	D'1'		;    
	SUBWF	REG9,W
	BTFSS	STATUS,Z
	GOTO	P_K105	
	CLRF	REG12			
	MOVF	REG6,W
	CALL	WRT
	DECFSZ	REG8,F
	GOTO	JK
	GOTO	JK_V

P_K105:			;  
	MOVLW	H'70'
	MOVWF	REG11
	MOVF	REG6,W
	CALL	WRITE_B
	MOVLW	D'13'
	MOVWF	REG12
P_K103:	CALL	MMC_BYTE
	MOVWF	REG6
	SUBLW	H'20'		;  ?
	BTFSC	STATUS,Z
	GOTO	P_K106
	MOVF	REG6,W
	CALL	WRITE_B
	DECFSZ	REG12,F
	GOTO	P_K103

		;  
	MOVLW	D'14'
	MOVWF	REG12
	MOVLW	H'70'
	MOVWF	REG11

P_K104:	CALL	READ_B
	CALL	WRT_C
	DECFSZ	REG12,F
	GOTO	P_K104

	GOTO	P_K109

P_K110:	MOVLW	D'13'
	MOVWF	REG8
P_K109:	CALL	MMC_BYTE
	MOVWF	REG6
	SUBLW	H'20'
	BTFSC	STATUS,Z	;   
	GOTO	P_K108		
	MOVF	REG6,W
	CALL	WRT
	DECFSZ	REG8,F
	GOTO	P_K109
	DECFSZ	REG9,F
	GOTO	P_K110

	GOTO	JK_V

P_K108:	MOVLW	H'20'
	CALL	WRT_C
	CLRF	REG12
	DECF	REG12,F
	GOTO	JK

P_K106:				;,      
	MOVF	REG8,W
	MOVWF	REG0
	MOVLW	H'70'
	SUBWF	REG11,W
	SUBWF	REG0,F
	ADDWF	REG0,W
	BTFSC	STATUS,C	
	GOTO	P_K107			;  

P_K114:
	MOVLW	H'70'		; 
	SUBWF	REG11,W
	MOVWF	REG12
	MOVLW	H'70'
	MOVWF	REG11
P_K112:	CALL	READ_B
	CALL	WRT_C
	DECFSZ	REG12,F
	GOTO	P_K112

	MOVF	REG9,F		
	BTFSC	STATUS,Z	;    
	GOTO	JK_V
	CLRF	REG12
	DECF	REG12,F
	MOVF	REG8,W
	SUBLW	D'13'
	BTFSC	STATUS,Z
	GOTO	JK

	MOVLW	H'20'
	CALL	WRT_C
	MOVF	REG9,F		
	BTFSC	STATUS,Z	;    
	GOTO	JK_V
	GOTO	JK

P_K107:	MOVLW	H'20'		;    
	CALL	WRT
	DECFSZ	REG8,F
	GOTO	P_K107
	MOVLW	D'13'
	MOVWF	REG8
	DECF	REG9,F
	GOTO	P_K114


JK_V:	CALL	WRITE_VRAM
	GOTO	LABEL



;---------------   
WRITE_B:
	MOVWF	REG0
	MOVF	REG11,W
	MOVWF	FSR
	MOVF	REG0,W
	MOVWF	INDF
	INCF	REG11,F
	RETURN


;----------------   
READ_B:
	MOVF	REG11,W
	MOVWF	FSR
	INCF	REG11,F
	MOVF	INDF,W
	
	RETURN


;----------------    VRAM
WRT_C:	MOVWF	REG0
	DECFSZ	REG8,F
	GOTO	WRT_1
	DECF	REG9,F
	MOVLW	D'13'	
	MOVWF	REG8
WRT_1:	MOVF	REG0,W
WRT:	MOVWF	REG0
	MOVF	REG10,W

	MOVWF	FSR
	MOVF	REG0,W
	MOVWF	INDF
	INCF	REG10,W
	SUBLW	H'F0'		;     VRAM
	BTFSS	STATUS,Z	
	INCF	REG10,F

	RETURN

;----------------    MMC
MMC_BYTE:
	INCF	NSEK,W			;   
	BTFSC	STATUS,Z
	GOTO	END_FILE

	CALL	SPI_FC
	MOVWF	REG7
	INCF	SEK_C_H,W	;   
	BTFSS	STATUS,Z
	GOTO	LK1
	DECF	NSEK,F		;   
	BTFSS	STATUS,Z
	GOTO	LK2

	CALL	SPI_F		;    
	CALL	SPI_F

	MOVF	NFAT_H,W
	MOVWF	REG3
	MOVF	NFAT_L,W
	MOVWF	REG4

	INCF	REG3,W		;   
	BTFSS	STATUS,Z
	GOTO	PR
	CLRF	NSEK
	DECF	NSEK,F
	GOTO	END_FILE

PR:
	CALL	FAT_NEXT
	MOVF	REG3,W
	MOVWF	NFAT_H
	MOVF	REG4,W
	MOVWF	NFAT_L
	CALL	FAT_FIZ


	CALL	MMC_READ
	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
	MOVLW	H'08'
	MOVWF	NSEK

	INCF	PFAT_L,F
	BTFSC	STATUS,Z
	INCF	PFAT_H,F

	GOTO	LK1

LK2:	CALL	SPI_F		; ,   
	CALL	SPI_F


TR:
	MOVLW	H'FF'		
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
	MOVLW	H'02'
	ADDWF	A_L_H,F
	BTFSS	STATUS,C
	GOTO	LK2_2
	INCF	A_H_L,F
	BTFSS	STATUS,Z
	GOTO	LK2_2
	INCF	A_H_H,F
LK2_2:	CALL	MMC_READ
LK1:	MOVF	REG7,W
	RETURN

END_FILE:
	CLRW			; 
	RETURN
;*********************
;******* 
;*********************
P_KEY2:	MOVLW	D'200'		
	CALL	PAUSE_MK
	BTFSS	PORTA,KEY2
	GOTO	P_KEY2

	MOVF	NSEK,W
	SUBLW	D'8'
	BTFSC	STATUS,Z
	GOTO	P_KEY1

P_K21:	CALL	SPI_FC
	INCF	SEK_C_H,W
	BTFSS	STATUS,Z
	GOTO	P_K21

	INCF	NSEK,F
	MOVLW	D'2'
	SUBWF	A_L_H,F
	MOVF	A_L_H,W
	ADDLW	D'2'
	BTFSS	STATUS,C
	GOTO	P_K22
	DECF	A_H_L,F
	INCF	A_H_L,W
	BTFSC	STATUS,C
	DECF	A_H_H,F
	

P_K22:	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
	CALL	MMC_READ

	GOTO	P_KEY1

;********************
;********** 
;********************
P_KEY3:	MOVLW	D'200'		
	CALL	PAUSE_MK			
	BTFSS	PORTA,KEY3
	GOTO	P_KEY3


;-------  
P_K3:	CALL	CON
	CALL	LCD_R
	MOVLW	B'01000000'	; Y
	CALL	LCD_C
	MOVLW	B'10001100'	; X(12)
	CALL	LCD_C
	CALL	N_CON

	MOVLW	D'10'
	MOVWF	REG4
MN1_1:	MOVF	REG4,W
	SUBLW	D'10'
	CALL	TABL
	CALL	SMB
	DECFSZ	REG4,F
	GOTO	MN1_1

	CALL	CON
	MOVLW	B'01000001'	; Y
	CALL	LCD_C
	MOVLW	B'10000110'	; X
	CALL	LCD_C
	CALL	N_CON

	MOVLW	D'10'
	MOVWF	REG6
	MOVLW	D'04'
	MOVWF	REG4
MN1_2:	MOVLW	D'06'
	MOVWF	REG5
MN1_3:	MOVF	REG5,W
	SUBLW	D'06'
	ADDWF	REG6,W
	CALL	TABL
	CALL	SMB
	DECFSZ	REG5,F
	GOTO	MN1_3

	CALL	CON
	MOVF	REG4,W		; Y
	SUBLW	D'06'
	MOVWF	REG0
	BSF	REG0,6
	MOVF	REG0,W
	CALL	LCD_C
	MOVLW	B'10000110'	; X
	CALL	LCD_C
	CALL	N_CON

	MOVF	REG6,W
	ADDLW	D'6'
	MOVWF	REG6
	DECFSZ	REG4,F
	GOTO	MN1_2


	MOVLW	D'4'
	MOVWF	REG4
	GOTO	MN1_K1

MN1_LAB:			;   
	CALL	KEY_READ
	MOVWF	REG0
	BTFSC	REG0,0
	GOTO	MN1_K1
	BTFSC	REG0,1
	GOTO	MN1_K2
	BTFSC	REG0,2
	GOTO	MN1_K3

	GOTO	P_KEY1

MN1_K1:	INCF	REG4,W			;   
	SUBLW	D'5'
	BTFSC	STATUS,Z
	CLRF	REG4
	INCF	REG4,F
	CALL	MN1_WR
	GOTO	MN1_LAB

MN1_K2:	DECF	REG4,W			;   
	BTFSC	STATUS,Z
	MOVLW	D'4'
	MOVWF	REG4
	CALL	MN1_WR
	GOTO	MN1_LAB

MN1_K3:	MOVLW	D'1'		;   ""
	SUBWF	REG4,W
	BTFSC	STATUS,Z
	GOTO	PMN1

	MOVLW	D'2'		;-//- ""
	SUBWF	REG4,W
	BTFSC	STATUS,Z
	GOTO	PMN2

	MOVLW	D'3'		;-//- ""
	SUBWF	REG4,W
	BTFSC	STATUS,Z
	GOTO	PMN3

				;    "."	
;---------------  4 "."
PMN4:	CALL	CON
	CALL	LCD_R
	MOVLW	B'01000000'		; Y
	CALL	LCD_C
	MOVLW	B'10001100'		; X
	CALL	LCD_C
	CALL	N_CON

	MOVLW	D'10'
	MOVWF	REG6
PMN4_8:	MOVF	REG6,W
	SUBLW	D'10'
	CALL	TABL
	CALL	SMB
	DECFSZ	REG6,F
	GOTO	PMN4_8

	CALL	CON
	MOVLW	B'01000001'
	CALL	LCD_C
	MOVLW	B'10000110'
	CALL	LCD_C
	CALL	N_CON

	MOVLW	D'50'
	MOVWF	REG5


	MOVLW	D'4'		;  
	MOVWF	REG6
PMN4_2:	MOVLW	D'6'
	MOVWF	REG4
PMN4_1:	MOVF	REG5,W
	CALL	TABL
	CALL	SMB
	INCF	REG5,F
	DECFSZ	REG4,F
	GOTO	PMN4_1	
	CALL	CON
	MOVLW	B'10000110'		; 
	CALL	LCD_C
	MOVF	REG6,W			; Y
	SUBLW	D'6'
	MOVWF	REG0
	BSF	REG0,6
	MOVF	REG0,W
	CALL	LCD_C
	CALL	N_CON
	DECFSZ	REG6,F
	GOTO	PMN4_2


	CALL	OPT_READ

	MOVLW	D'4'
	MOVWF	REG4
	GOTO	P4_K1

P4_LAB:	CALL	KEY_READ		;  
	MOVWF	REG0
	BTFSC	REG0,0
	GOTO	P4_K1
	BTFSC	REG0,1
	GOTO	P4_K2
	BTFSC	REG0,2
	GOTO	P4_K3

P4_K4:	GOTO	P_K3	

P4_K1:	INCF	REG4,W			;   
	SUBLW	D'5'
	BTFSC	STATUS,Z
	CLRF	REG4
	INCF	REG4,F
	CALL	MN1_WR
	GOTO	P4_LAB

P4_K2:	DECF	REG4,W			;   
	BTFSC	STATUS,Z
	MOVLW	D'4'
	MOVWF	REG4
	CALL	MN1_WR
	GOTO	P4_LAB

P4_K3:	MOVLW	D'01'		;  
	SUBWF	REG4,W
	BTFSS	STATUS,Z
	GOTO	P4_K31
	MOVF	OPT,W
	MOVWF	REG0
	BSF	OPT,7
	BTFSC	REG0,7
	BCF	OPT,7
	CALL	OPT_READ
	GOTO	P4_LAB	

P4_K31:	MOVLW	D'02'		;  
	SUBWF	REG4,W
	BTFSS	STATUS,Z
	GOTO	P4_K32
	MOVF	OPT,W
	ANDLW	B'00001111'
	MOVWF	REG0
	INCF	REG0,F
	MOVLW	D'10'
	SUBWF	REG0,W
	BTFSC	STATUS,Z
	CLRF	REG0
	MOVLW	B'11110000'
	ANDWF	OPT,F
	MOVF	REG0,W
	IORWF	OPT,F	
	CALL	OPT_READ
	CLRF	AVT_0
	CLRF	AVT_1
	MOVF	OPT,W
	ANDLW	B'00001111'
	MOVWF	AVT_2
	INCF	AVT_2,F

	GOTO	P4_LAB


P4_K32:	MOVLW	D'03'		;  
	SUBWF	REG4,W
	BTFSS	STATUS,Z
	GOTO	P4_K33
	MOVF	OPT,W
	MOVWF	REG0
	BSF	OPT,6
	BTFSC	REG0,6
	BCF	OPT,6
	CALL	OPT_READ

	BTFSS	OPT,6
	GOTO	P4_K321
	CALL	CON		; 
	MOVLW	B'00001101'
	CALL	LCD_C
	CALL	N_CON
	GOTO	P4_LAB	
P4_K321:			; 
	CALL	CON	
	MOVLW	B'00001100'
	CALL	LCD_C
	CALL	N_CON
	GOTO	P4_LAB			

P4_K33:	MOVF	OPT,W		;  
	MOVWF	REG0
	BSF	OPT,5
	BTFSC	REG0,5
	BCF	OPT,5
	CALL	OPT_READ
	GOTO	P4_LAB	
	

OPT_READ:
	CALL	CON		;
	MOVLW	B'01000001'
	CALL	LCD_C
	MOVLW	B'10110000'
	CALL	LCD_C
	CALL	N_CON
	MOVLW	D'89'	;Y
	BTFSS	OPT,7
	MOVLW	D'78'	;N
	CALL	SMB

	CALL	CON		;
	MOVLW	B'01000010'
	CALL	LCD_C
	MOVLW	B'10110000'
	CALL	LCD_C
	CALL	N_CON
	MOVF	OPT,W
	ANDLW	B'00001111'
	MOVWF	REG0
	MOVLW	D'48'	;0
	ADDWF	REG0,W
	CALL	SMB

	CALL	CON		;
	MOVLW	B'01000011'
	CALL	LCD_C
	MOVLW	B'10110000'
	CALL	LCD_C
	CALL	N_CON
	MOVLW	D'89'	;Y
	BTFSS	OPT,6
	MOVLW	D'78'	;N
	CALL	SMB

	CALL	CON		;
	MOVLW	B'01000100'
	CALL	LCD_C
	MOVLW	B'10110000'
	CALL	LCD_C
	CALL	N_CON
	MOVLW	D'89'	;Y
	BTFSS	OPT,5
	MOVLW	D'78'	;N
	CALL	SMB
	RETURN
;-----------  1 ""
PMN1:	
	MOVLW	D'1'
	MOVWF	REG11		; 
PMN111:
	CLRF	REG8		; 
	CLRF	REG9		; 
	CLRF	REG10		;  

	MOVLW	D'2'		;  ,    
	MOVWF	REG6
	MOVLW	D'250'
	MOVWF	REG5
PMN1_1:	CALL	SPI_F
	DECFSZ	REG5,F
	GOTO	PMN1_1
	DECFSZ	REG6,F
	GOTO	PMN1_1		

	MOVLW	H'00'
	MOVWF	A_H_H
	MOVWF	A_H_L
	MOVWF	A_L_L
	MOVF	ROD,W
	MOVWF	A_L_H

P1_N1:	CALL	MMC_READ		;  Root Directori
	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'1'
	MOVWF	SEK_C_H


P1_N2:					;  
	CLRF	REG6
	MOVLW	H'5'
	MOVWF	REG4
PMN1_2:	CALL	CON
	MOVLW	B'10000110'		; X
	CALL	LCD_C
	MOVF	REG4,W			; Y
	SUBLW	D'6'
	MOVWF	REG0
	BSF	REG0,6
	MOVF	REG0,W
	CALL	LCD_C
	CALL	N_CON

	CALL	SPI_FC		;   Root Directori  
	MOVWF	REG0
	MOVF	REG0,F
	BTFSC	STATUS,Z
	GOTO	GK1_1

	INCF	REG6,F
	MOVF	REG0,W
	CALL	SMB
	MOVLW	D'10'
	MOVWF	REG5
GK:	CALL	SPI_FC		;  
	CALL	SMB
	DECFSZ	REG5,F
	GOTO	GK

	MOVLW	D'21'		;  
	MOVWF	REG5
GK1:	CALL	SPI_FC
	DECFSZ	REG5,F
	GOTO	GK1
	GOTO	GK1_3
	
GK1_1:	MOVLW	D'255'		;  
	MOVWF	REG9
	MOVLW	D'11'
	MOVWF	REG5
GK1_2:	MOVLW	H'00'
	CALL	SMB
	DECFSZ	REG5,F
	GOTO	GK1_2

GK1_3:	INCF	SEK_C_H,W	
	BTFSS	STATUS,Z	;   	
	GOTO	GK141
	MOVLW	D'2'		;   
	ADDWF	A_L_H,F
	BTFSC	STATUS,C
	INCF	A_H_L,F
	MOVF	REG4,W
	MOVWF	REG15
	CALL	MMC_READ
	MOVF	REG15,W
	MOVWF	REG4
	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
GK141:	DECFSZ	REG4,F
	GOTO	PMN1_2




;------------  
PMN1_L2:
	MOVF	REG11,W
	MOVWF	REG4
	CALL	MN1_WR

PMN1_LAB:
	CALL	KEY_READ
	MOVWF	REG0
	BTFSC	REG0,0
	GOTO	PMN1_K1
	BTFSC	REG0,1
	GOTO	PMN1_K2
	BTFSC	REG0,2
	GOTO	PMN1_K3


PMN1_K4:			;  
	CALL	SPI_FC
	INCF	SEK_C_H,W
	BTFSS	STATUS,Z
	GOTO	PMN1_K4

	MOVF	NFAT_L,W
	MOVWF	REG4
	MOVF	NFAT_H,W
	MOVWF	REG3
	CALL	FAT_FIZ
	MOVF	NSEK,W
	SUBLW	D'8'
	MOVWF	REG0
	RLF	REG0,F
	BCF	REG0,0
	MOVF	REG0,W
	ADDWF	A_L_H,F
	BTFSS	STATUS,C
	GOTO	P1_K41	
	INCF	A_H_L,F
	BTFSC	STATUS,C
	INCF	A_H_H,F
P1_K41:	CALL	MMC_READ
	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
	MOVLW	D'08'
	MOVWF	NSEK
	GOTO	P_K3

			
PMN1_K1:INCF	REG4,F		; 
	MOVF	REG4,W
	SUBWF	REG6,W
	ADDWF	REG4,W
	BTFSC	STATUS,C	;    ???
	GOTO	PM1K11
	CALL	MN1_WR
	GOTO	PMN1_LAB

PM1K11:	MOVF	REG9,F
	BTFSS	STATUS,Z	;   
	GOTO	PMN1
	MOVLW	D'5'
	ADDWF	REG10,F
	MOVLW	D'1'
	MOVWF	REG11
	GOTO	P1_N2		



PMN1_K2:			; 
	DECF	REG4,F
	BTFSC	STATUS,Z
	GOTO	PM1K21	
	CALL	MN1_WR
	GOTO	PMN1_LAB

PM1K21:	MOVF	REG10,F		;    
	BTFSC	STATUS,Z
	GOTO	PMN1_L2
	
	MOVLW	D'5'
	MOVWF	REG11		; 
	SUBWF	REG10,W
	MOVWF	REG10
	MOVWF	REG12
	GOTO	PMN111	


	GOTO	P1_N2


VIB_FIL:			; 
	CALL	SPI_FC
	INCF	SEK_C_H,W
	BTFSS	STATUS,Z
	GOTO	VIB_FIL

	MOVF	REG4,W
	ADDWF	REG10,F


kp:
	MOVLW	H'FF'
	MOVWF	REG9	; 
	DECF	REG10,F
P1K32:	INCF	REG9,F
	MOVLW	D'16'
	SUBWF	REG10,F
	MOVF	REG10,W
	ADDLW	D'16'
	BTFSS	STATUS,C
	GOTO	P1K32	

	MOVWF	REG7	;  
	INCF	REG7,F


	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'1'
	MOVWF	SEK_C_H

	MOVLW	H'00'
	MOVWF	A_H_H
	MOVWF	A_H_L
	MOVWF	A_L_L
	MOVF	ROD,W
	MOVWF	A_L_H
	RLF	REG9,F
	BCF	REG9,0
	MOVF	REG9,W
	ADDWF	A_L_H,F
	CALL	MMC_READ

P1_K33:	DECF	REG7,F		;   
	MOVF	REG7,F
	BTFSC	STATUS,Z
	GOTO	P1_K31
	MOVLW	D'32'
	MOVWF	REG4
P1_K32:	CALL	SPI_FC
	DECFSZ	REG4,F
	GOTO	P1_K32
	GOTO	P1_K33
	RETURN



PMN1_K3:
	CALL	VIB_FIL
P1_K31:	MOVLW	D'26'
	MOVWF	REG4
P1_K34:	CALL	SPI_FC
	DECFSZ	REG4,F
	GOTO	P1_K34

	CALL	SPI_FC		;  
	MOVWF	NFAT_H
	MOVWF	KL_E_H
	CALL	SPI_FC
	MOVWF	NFAT_L
	MOVWF	KL_E_L

	CLRF	PFAT_L		;  
	CLRF	PFAT_H

	CALL	SPI_FC		;   
	MOVWF	SIZE_H
	CALL	SPI_FC
	MOVWF	SIZE_L
	CALL	SPI_FC
	CALL	SPI_FC



P1_K35:	CALL	SPI_FC
	INCF	SEK_C_H,W
	BTFSS	STATUS,Z
	GOTO	P1_K35


	CALL	SPI_F


TMP99:
	CLRF	CSEK		;  
	MOVF	SIZE_H,W
	MOVWF	REG1
	MOVF	SIZE_L,W
	MOVWF	REG0
	RLF	REG0,F
	RLF	REG1,F
	BCF	REG0,0
P1_K391:
	MOVLW	D'11'		;CSEK=SIZE*2/11;
	SUBWF	REG0,F
	MOVF	REG0,W
	ADDLW	D'11'
	BTFSC	STATUS,C
	DECF	REG1,F
	INCF	CSEK,F
	INCF	REG1,W
	BTFSS	STATUS,Z
	GOTO	P1_K391


	MOVF	NFAT_L,W
	MOVWF	REG4
	MOVF	NFAT_H,W
	MOVWF	REG3
	CALL	FAT_FIZ
	
	CALL	MMC_READ
	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
	MOVLW	D'08'
	MOVWF	NSEK

	GOTO	P_KEY1

;----------------  2 ""
PMN2:	CALL	CON
	CALL	LCD_R
	MOVLW	B'01000000'	; Y
	CALL	LCD_C
	MOVLW	B'10001100'	; X(12)
	CALL	LCD_C
	CALL	N_CON

	MOVLW	D'10'
	MOVWF	REG4
PMN2_8:	MOVF	REG4,W
	SUBLW	D'10'
	CALL	TABL
	CALL	SMB
	DECFSZ	REG4,F
	GOTO	PMN2_8

	CALL	CON
	MOVLW	B'01000001'	; Y
	CALL	LCD_C
	MOVLW	B'10000110'	; X(12)
	CALL	LCD_C
	CALL	N_CON
	
	MOVLW	D'34'
	MOVWF	REG5

	MOVLW	D'4'		;  
	MOVWF	REG6
PMN2_2:	MOVLW	D'4'
	MOVWF	REG4
PMN2_1:	MOVF	REG5,W
	CALL	TABL
	CALL	SMB
	INCF	REG5,F
	DECFSZ	REG4,F
	GOTO	PMN2_1	
	CALL	CON
	MOVLW	B'10000110'		; 
	CALL	LCD_C
	MOVF	REG6,W			; Y
	SUBLW	D'6'
	MOVWF	REG0
	BSF	REG0,6
	MOVF	REG0,W
	CALL	LCD_C
	CALL	N_CON
	DECFSZ	REG6,F
	GOTO	PMN2_2

	MOVLW	D'4'	
	MOVWF	REG4
	GOTO	PMN2_K1
PMN2_LAB:
	CALL	KEY_READ
	MOVWF	REG0
	BTFSC	REG0,0
	GOTO	PMN2_K1
	BTFSC	REG0,1
	GOTO	PMN2_K2
	BTFSC	REG0,2
	GOTO	PMN2_K3
	
	GOTO	P_K3

PMN2_K1:INCF	REG4,W
	SUBLW	D'5'
	BTFSC	STATUS,Z
	CLRF	REG4
	INCF	REG4,F
	CALL	MN1_WR
	GOTO	PMN2_LAB

PMN2_K2:DECF	REG4,W
	BTFSC	STATUS,Z
	MOVLW	D'4'
	MOVWF	REG4
	CALL	MN1_WR
	GOTO	PMN2_LAB

PMN2_K3:MOVLW	D'01'		;"1"
	SUBWF	REG4,W
	BTFSS	STATUS,Z
	GOTO	P2_K31
	MOVLW	D'14'
	GOTO	P2_K34

P2_K31:
	MOVLW	D'02'		;"2"
	SUBWF	REG4,W
	BTFSS	STATUS,Z
	GOTO	P2_K32
	MOVLW	D'28'
	GOTO	P2_K34

P2_K32: MOVLW	D'03'		;"3"
	SUBWF	REG4,W
	BTFSS	STATUS,Z
	GOTO	P2_K33
	MOVLW	D'32'		
	GOTO	P2_K34

;----------- O 
P2_K33:				;""
	MOVLW	D'5'
	MOVWF	REG4
	
P2K33L:	CALL	PROZ
	CALL	KEY_READ
	MOVWF	REG0
	BTFSC	REG0,0
	GOTO	P2K331
	BTFSC	REG0,1
	GOTO	P2K332
	BTFSC	REG0,2
	GOTO	P2K333
	
	GOTO	PMN2

P2K331:	DECF	REG4,F		;  
	BTFSS	STATUS,Z
	GOTO	P2K33L
	MOVLW	D'9'
	MOVWF	REG4
	GOTO	P2K33L	

P2K332:	INCF	REG4,F		;  
	MOVF	REG4,W
	SUBLW	D'10'
	BTFSS	STATUS,Z
	GOTO	P2K33L
	MOVLW	D'1'
	MOVWF	REG4
	GOTO	P2K33L	

P2K333:	MOVF	SIZE_H,W
	MOVWF	REG5
	MOVF	SIZE_L,W	;SIZE*REG4
	MOVWF	REG6
	CLRF	REG7
	CLRF	REG8

P331:	MOVF	REG6,W
	ADDWF	REG8,F
	BTFSC	STATUS,C
	INCF	REG7,F
	MOVF	REG5,W
	ADDWF	REG7,F

	DECFSZ	REG4,F
	GOTO	P331

	MOVF	REG8,W
	MOVWF	REG6
	MOVF	REG7,W
	MOVWF	REG5

	CLRF	REG7		; 
	CLRF	REG8		;    

P332:	MOVLW	D'10'		;/10
	SUBWF	REG6,F
	MOVF	REG6,W
	ADDLW	D'10'
	BTFSC	STATUS,C
	DECF	REG5,F
	INCF	REG7,F
	INCF	REG5,W
	BTFSS	STATUS,Z
	GOTO	P332

	MOVF	REG6,W
	ADDLW	D'10'
	MOVWF	REG8
	BTFSC	STATUS,Z
	DECF	REG7,F

	MOVF	REG7,W
	MOVWF	PFAT_L
	CLRF	PFAT_H

	MOVLW	D'2'		;  ,    
	MOVWF	REG6
	MOVLW	D'255'
	MOVWF	REG5
P341:	CALL	SPI_F
	DECFSZ	REG5,F
	GOTO	P341
	DECFSZ	REG6,F
	GOTO	P341

	MOVF	KL_E_H,W
	MOVWF	REG3
	MOVF	KL_E_L,W
	MOVWF	REG4
P333:	CALL	FAT_NEXT
	CALL	SPI_F
	DECFSZ	REG7,F
	GOTO	P333

	MOVF	REG3,W
	MOVWF	NFAT_H
	MOVF	REG4,W
	MOVWF	NFAT_L

	CALL	FAT_FIZ

	MOVF	REG8,W
	SUBLW	D'8'
	MOVWF	NSEK
	
	RLF	REG8,F
	BCF	REG8,0
	MOVF	REG8,W
	ADDWF	A_L_H,F
	BTFSC	STATUS,C
	INCF	A_H_L,F
	BTFSC	STATUS,Z
	INCF	A_H_H,F

	CALL	MMC_READ
	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
	
	GOTO	P_KEY1



PROZ:	MOVF	REG4,W
	ANDLW	B'00001111'
	ADDLW	D'48'		;0
	MOVWF	REG5
	CALL	CON
	CALL	LCD_R
	MOVLW	B'01000010'	; Y
	CALL	LCD_C
	MOVLW	B'10011110'	; X
	CALL	LCD_C
	CALL	N_CON
	MOVF	REG5,W
	CALL	SMB
	MOVLW	D'48'		;0
	CALL	SMB
	MOVLW	D'32'		;' '
	CALL	SMB
	MOVLW	D'37'		;%
	CALL	SMB
	RETURN






P2_K34:
	MOVWF	REG5
	MOVLW	D'2'		;  ,    
	MOVWF	REG6
	MOVLW	D'255'
	MOVWF	REG7
P2_K341:
	CALL	SPI_F
	DECFSZ	REG7,F
	GOTO	P2_K341
	DECFSZ	REG6,F
	GOTO	P2_K341

	MOVF	REG5,W
	CALL	READ_FILE
	CALL	MMC_READ
	MOVLW	H'FF'
	MOVWF	SEK_C_L
	MOVLW	H'01'
	MOVWF	SEK_C_H
	GOTO	P_KEY1


;--------------   3 ""
PMN3:	CALL	CON
	CALL	LCD_R
	MOVLW	B'01000000'	; Y
	CALL	LCD_C
	MOVLW	B'10001100'	; X(12)
	CALL	LCD_C
	CALL	N_CON

	MOVLW	D'10'
	MOVWF	REG4
PMN3_8:	MOVF	REG4,W
	SUBLW	D'10'
	CALL	TABL
	CALL	SMB
	DECFSZ	REG4,F
	GOTO	PMN3_8



	CALL	CON
	MOVLW	B'01000001'	; Y
	CALL	LCD_C
	MOVLW	B'10000110'	; X(12)
	CALL	LCD_C
	CALL	N_CON
	
	MOVLW	D'34'
	MOVWF	REG5

	MOVLW	D'3'
	MOVWF	REG6
PMN3_2:	MOVLW	D'4'
	MOVWF	REG4
PMN3_1:	MOVF	REG5,W
	CALL	TABL
	CALL	SMB
	INCF	REG5,F
	DECFSZ	REG4,F
	GOTO	PMN3_1	
	CALL	CON
	MOVLW	B'10000110'
	CALL	LCD_C
	MOVF	REG6,W	
	SUBLW	D'5'
	MOVWF	REG0
	BSF	REG0,6
	MOVF	REG0,W
	CALL	LCD_C
	CALL	N_CON
	DECFSZ	REG6,F
	GOTO	PMN3_2

	MOVLW	D'3'	
	MOVWF	REG4
	GOTO	PMN3_K1

PMN3_LAB:
	CALL	KEY_READ
	MOVWF	REG0
	BTFSC	REG0,0
	GOTO	PMN3_K1
	BTFSC	REG0,1
	GOTO	PMN3_K2
	BTFSC	REG0,2
	GOTO	PMN3_K3
	
	GOTO	P_K3

PMN3_K1:INCF	REG4,W
	SUBLW	D'4'
	BTFSC	STATUS,Z
	CLRF	REG4
	INCF	REG4,F
	CALL	MN1_WR
	GOTO	PMN3_LAB

PMN3_K2:DECF	REG4,W
	BTFSC	STATUS,Z
	MOVLW	D'3'
	MOVWF	REG4
	CALL	MN1_WR
	GOTO	PMN3_LAB

PMN3_K3:MOVLW	D'01'		;"1"
	SUBWF	REG4,W
	BTFSS	STATUS,Z
	GOTO	P3_K31
	MOVLW	D'14'
	CALL	WRITE_FILE
	GOTO	P_KEY1

P3_K31:
	MOVLW	D'02'		;"2"
	SUBWF	REG4,W
	BTFSS	STATUS,Z
	GOTO	P3_K32
	MOVLW	D'28'
	CALL	WRITE_FILE
	GOTO	P_KEY1

P3_K32: MOVLW	D'42'		;"3"
	CALL	WRITE_FILE
	GOTO	P_KEY1


;***********     
MN1_WR:	MOVLW	D'5'
	MOVWF	REG5
K31:	CALL	CON
	MOVLW	B'10000000'	; X
	CALL	LCD_C
	BSF	REG5,6
	MOVF	REG5,W		; Y
	BCF	REG5,6
	CALL	LCD_C
	CALL	N_CON
	MOVLW	H'00'
	CALL	SMB
	DECFSZ	REG5,F
	GOTO	K31

	MOVF	REG4,W
	MOVWF	REG5
	BSF	REG5,6
	CALL	CON
	MOVLW	B'10000000'	; X
	CALL	LCD_C
	MOVF	REG5,W
	CALL	LCD_C
	CALL	N_CON
	MOVLW	D'62'		;>
	CALL	SMB
	RETURN


	GOTO	LABEL

;*********************
;*****  
;*********************
P_KEY4:	MOVLW	D'200'		
	CALL	PAUSE_MK			
	BTFSS	PORTA,KEY4
	GOTO	P_KEY4

	MOVLW	H'00'		;
	CALL	WRITE_FILE

	MOVLW	H'7F'		;  
	MOVWF	ADR_EEP
	MOVF	OPT,W
	CALL	WRITE_EE

SBR:				; 
	CALL	CON
	CALL	LCD_R
	CALL	N_CON

	BSF	STATUS,RP0	;   
	BCF	STATUS,RP1
	BSF	TRISB,SCLK
	BSF	TRISA,SDA	;  FLASH
	BSF	TRISA,SCL
	BCF	STATUS,RP0

	BSF	PORTB,CS	;    
	CALL	SPI_F

	GOTO	LB3		;   





;**********************************************************************
;*************                       **********************
;**********************************************************************
;************      EEPROM
READ_FILE:
	MOVWF	ADR_EEP

	CALL	READ_EE		;  
	MOVWF	A_H_H		
	INCF	ADR_EEP,F
	CALL	READ_EE
	MOVWF	A_H_L
	INCF	ADR_EEP,F
	CALL	READ_EE
	MOVWF	A_L_H
	INCF	ADR_EEP,F
	CALL	READ_EE
	MOVWF	A_L_L
	INCF	ADR_EEP,F


	CALL	READ_EE		;   
	MOVWF	PFAT_H		
	INCF	ADR_EEP,F
	CALL	READ_EE
	MOVWF	PFAT_L
	INCF	ADR_EEP,F


	CALL	READ_EE		;  
	MOVWF	NFAT_H		
	INCF	ADR_EEP,F
	CALL	READ_EE
	MOVWF	NFAT_L
	INCF	ADR_EEP,F

	CALL	READ_EE		;   
	MOVWF	KL_E_H		
	INCF	ADR_EEP,F
	CALL	READ_EE
	MOVWF	KL_E_L
	INCF	ADR_EEP,F

	CALL	READ_EE		;    
	MOVWF	NSEK	
	INCF	ADR_EEP,F
	
	CALL	READ_EE		;  
	MOVWF	CSEK	
	INCF	ADR_EEP,F


	CALL	READ_EE		;  
	MOVWF	SIZE_H	
	INCF	ADR_EEP,F
	CALL	READ_EE
	MOVWF	SIZE_L
	RETURN
;**************       EEPROM
WRITE_FILE:
	MOVWF	ADR_EEP

	MOVF	A_H_H,W		;   
	CALL	WRITE_EE
	INCF	ADR_EEP,F
	MOVF	A_H_L,W
	CALL	WRITE_EE
	INCF	ADR_EEP,F
	MOVF	A_L_H,W
	CALL	WRITE_EE
	INCF	ADR_EEP,F
	MOVF	A_L_L,W
	CALL	WRITE_EE
	INCF	ADR_EEP,F

	MOVF	PFAT_H,W	;  
	CALL	WRITE_EE
	INCF	ADR_EEP,F
	MOVF	PFAT_L,W
	CALL	WRITE_EE
	INCF	ADR_EEP,F


	MOVF	NFAT_H,W	;   
	CALL	WRITE_EE
	INCF	ADR_EEP,F
	MOVF	NFAT_L,W
	CALL	WRITE_EE
	INCF	ADR_EEP,F

	MOVF	KL_E_H,W	;   
	CALL	WRITE_EE
	INCF	ADR_EEP,F
	MOVF	KL_E_L,W
	CALL	WRITE_EE
	INCF	ADR_EEP,F



	MOVF	NSEK,W		;    
	CALL	WRITE_EE
	INCF	ADR_EEP,F

	MOVF	CSEK,W		;  
	CALL	WRITE_EE
	INCF	ADR_EEP,F

	MOVF	SIZE_H,W	;  
	CALL	WRITE_EE
	INCF	ADR_EEP,F
	MOVF	SIZE_L,W
	CALL	WRITE_EE
	RETURN
;*************** 
KEY_READ:
	BTFSS	PORTA,KEY1
	GOTO	KR1
	BTFSS	PORTA,KEY2
	GOTO	KR2
	BTFSS	PORTA,KEY3
	GOTO	KR3
	BTFSS	PORTA,KEY4
	GOTO	KR4
	GOTO	KEY_READ

KR1:	MOVLW	D'200'
	CALL	PAUSE_MK
	BTFSS	PORTA,KEY1
	GOTO	KR1

	RETLW	B'00000001'
	
KR2:	MOVLW	D'200'
	CALL	PAUSE_MK
	BTFSS	PORTA,KEY2
	GOTO	KR2

	RETLW	B'00000010'

KR3:	MOVLW	D'200'
	CALL	PAUSE_MK
	BTFSS	PORTA,KEY3
	GOTO	KR3

	RETLW	B'00000100'

KR4:	MOVLW	D'200'
	CALL	PAUSE_MK
	BTFSS	PORTA,KEY4
	GOTO	KR4

	RETLW	B'00001000'



;**********  
;------     W
SKROL:	MOVWF	REG3
	MOVF	REG3,F
	BTFSS	STATUS,Z
	DECF	REG3,F
	MOVLW	D'6'
	MOVWF	REG2
	CLRF	REG9	


	CALL	CON
SKR1:	MOVF	REG2,W
	SUBLW	D'6'
	IORLW	B'01000000'	; Y
	CALL	LCD_C
	MOVLW	B'11010000'	; X
	CALL	LCD_C

	INCF	REG3,W
	BTFSC	STATUS,Z
	GOTO	SKR3
	MOVLW	D'8'
	SUBWF	REG3,W
	ADDLW	D'8'
	BTFSS	STATUS,C	;     
	GOTO	SKR2

	MOVLW	B'00011111'
	MOVWF	REG4
	MOVLW	B'11111011'
	MOVWF	REG5
	MOVLW	B'11110101'
	MOVWF	REG6
	MOVLW	B'00011111'
	MOVWF	REG7
	
	MOVF	REG9,F		;,    
	BTFSS	STATUS,Z
	GOTO	SKR10


	MOVF	REG3,W		;  
	MOVWF	REG8
	MOVF	REG3,F
	BTFSC	STATUS,Z	
	GOTO	SKR6_1

SKR6:	RLF	REG4,F		;   
	BCF	REG4,0

	RLF	REG5,F
	BSF	REG5,0

	RLF	REG6,F
	BSF	REG6,0

	RLF	REG7,F
	BCF	REG7,0

	DECFSZ	REG8,F
	GOTO	SKR6
SKR6_1:
	MOVLW	D'4'
	SUBWF	REG3,W
	ADDLW	D'4'
	BTFSS	STATUS,C	;,      
	GOTO	SKR4
	CLRF	REG3
	DECF	REG3,F
	GOTO	SKR7
SKR4:	DECF	REG9,F
	MOVF	REG3,W
	SUBLW	D'8'
	MOVWF	REG3
	GOTO	SKR7

SKR10:	RRF	REG4,F		;  
	BCF	REG4,7

	RRF	REG5,F
	BSF	REG5,7

	RRF	REG6,F
	BSF	REG6,7

	RRF	REG7,F
	BCF	REG7,7

	DECFSZ	REG3,F
	GOTO	SKR10
	
	CLRF	REG3
	DECF	REG3,F
	CLRF	REG9


SKR7:	MOVF	REG4,W		;   
	CALL	LCD_D
	MOVF	REG5,W
	CALL	LCD_D
	MOVF	REG6,W
	CALL	LCD_D
	MOVF	REG7,W
	CALL	LCD_D
	GOTO	SKR5

SKR2:	MOVLW	D'7'		;   
	SUBWF	REG3,F		
SKR3:	CLRW			;  
	CALL	LCD_D
	MOVLW	D'255'
	CALL	LCD_D
	MOVLW	D'255'
	CALL	LCD_D
	CLRW	
	CALL	LCD_D
SKR5:	DECFSZ	REG2,F
	GOTO	SKR1

	CALL	N_CON
	RETURN
;***********      (REG0-REG5,ADR_FLH,ADR_FLL)
WRITE_VRAM:
			; 
	CLRF	REG0				;W=(PFAT*8 + NSEK)/CSEK
	MOVF	PFAT_L,W
	MOVWF	REG1
	MOVF	PFAT_H,W
	MOVWF	REG2
	RLF	REG1,F
	RLF	REG2,F
	RLF	REG1,F
	RLF	REG2,F
	RLF	REG1,F
	RLF	REG2,F
	MOVLW	B'11111000'
	ANDWF	REG1,F
	MOVF	NSEK,W
	SUBLW	D'8'
	ADDWF	REG1,F
	BTFSC	STATUS,C
	INCF	REG2,F
WRM3:	MOVF	CSEK,W
	SUBWF	REG1,F
	MOVF	REG1,W
	ADDWF	CSEK,W
	BTFSC	STATUS,C
	DECF	REG2,F
	INCF	REG0,F
	INCF	REG2,W
	BTFSS	STATUS,Z
	GOTO	WRM3
	
	INCF	NSEK,W		;   
	BTFSS	STATUS,Z
	GOTO	KI
	MOVLW	D'44'
	MOVWF	REG0
KI:
	MOVF	REG0,W
	MOVWF	REG6

	CALL	CON
	MOVLW	B'01000000'	; Y
	CALL	LCD_C
	MOVLW	B'10000000'	; X
	CALL	LCD_C
	CALL	N_CON

	BCF	STATUS,IRP
	MOVLW	H'A0'
	MOVWF	FSR

	MOVLW	D'06'
	MOVWF	REG4
GH:	MOVLW	D'13'
	MOVWF	REG5
GH1:	MOVF	INDF,W
	CALL	SMB
	INCF	FSR,F
	DECFSZ	REG5,F
	GOTO	GH1
	CALL	CON
	MOVF	REG4,W
	SUBLW	D'7'		; Y
	IORLW	B'01000000'
	CALL	LCD_C
	MOVLW	B'10000000'	; X
	CALL	LCD_C
	CALL	N_CON
	DECFSZ	REG4,F
	GOTO	GH
		
	MOVF	REG6,W		; 
	CALL	SKROL

	RETURN






;**************     (REG0-REG4,A_H_H-A_L_L)
;------------     REG3,REG4
FAT_FIZ:
	CLRF	A_H_H
	CLRF	A_H_L
	MOVF	DAT,W
	MOVWF	A_L_H
	CLRF	A_L_L
	CLRF	REG1
	CLRF	REG2

	MOVLW	D'12'		;REG = 8*512 * FAT
	MOVWF	REG0
F1:	RLF	REG4,F
	BCF	REG4,0
	RLF	REG3,F
	RLF	REG2,F
	RLF	REG1,F
	DECFSZ	REG0,F
	GOTO	F1

	MOVF	REG4,W		;A=REG+DAT
	MOVWF	A_L_L
	MOVF	REG3,W
	ADDWF	A_L_H,F
	BTFSC	STATUS,C
	INCF	A_H_L,F
	BTFSC	STATUS,Z
	INCF	A_H_H,F
	MOVF	REG2,W
	ADDWF	A_H_L,F
	BTFSC	STATUS,C
	INCF	A_H_H,F
	MOVF	REG1,W
	ADDWF	A_H_H,F
	RETURN







;******    FAT ******* (REG0-REG6)
;----   REG3  REG4,  -
FAT_NEXT:
	MOVLW	H'00'		;    FAT
	MOVWF	A_H_H
	MOVWF	A_H_L
	MOVWF	A_L_L
	MOVF	FAT,W
	MOVWF	A_L_H
	RLF	REG3,F
	BCF	REG3,0
	MOVF	REG3,W
	ADDWF	A_L_H,F
	CLRF	REG3
	RLF	REG4,F
	RLF	REG3,F
	BCF	REG4,0
	CALL	BYTE_READ
	RETURN


;*****   *** (REG0,REG1,REG2,REG3,REG4)
MMC_READ:
	BSF	PORTB,CS
	CALL	SPI_F
	CALL	SPI_F
	BCF	PORTB,CS

	MOVLW	H'08'
	MOVWF	REG4
MMCR:	MOVLW	H'51'		;  
	CALL	COMM
	MOVWF	REG1
	MOVLW	D'255'
	MOVWF	REG3

	GOTO	M2

M1:	CALL	SPI_F
	MOVWF	REG1

M2:	DECF	REG3,F		;  
	BTFSS	STATUS,Z	
	GOTO	M2_2
	DECF	REG4,F
	BTFSS	STATUS,Z
	GOTO	MMCR
	BCF	REG1,0
M2_2:
	BTFSC	REG1,0
	GOTO	M1



	MOVLW	D'255'
	MOVWF	REG4
	MOVLW	H'40'
	MOVWF	REG3
M1_1:	CALL	SPI_F		;  
	SUBLW	H'FE'
	MOVWF	REG1

	DECF	REG4,F		;  
	BTFSC	STATUS,Z	
	DECF	REG3,F
	MOVF	REG3,F
	BTFSC	STATUS,Z
	CLRF	REG1

	MOVF	REG1,F
	BTFSS	STATUS,Z
	GOTO	M1_1
	RETURN	




;******      ****(REG0 - REG6)
;-----   REG3  REG4,   
BYTE_READ:	
	MOVF	REG3,W
	MOVWF	REG5
	MOVF	REG4,W
	MOVWF	REG6

	CALL	MMC_READ


;--  0  511
	CLRF	REG3
	CLRF	REG4

	GOTO	CK1

CK0:	INCF	REG4,F		; 1   
	BTFSS	STATUS,Z
	GOTO	CK1
	INCF	REG3,F
	BTFSC	REG3,1		;   
	GOTO	CK2
CK1:	MOVF	REG5,W
	SUBWF	REG3,W
	BTFSS	STATUS,Z	;   
	GOTO	KC1
	MOVF	REG6,W
	SUBWF	REG4,W
	BTFSS	STATUS,Z	;   
	GOTO	KC1

	CALL	SPI_F		;  
	MOVWF	REG5
	CALL	SPI_F
	MOVWF	REG6
	INCF	REG4,F
	BTFSS	STATUS,C
	GOTO	CK1_0
	INCF	REG3,F
	BTFSC	REG3,1
	GOTO	CK2
CK1_0:	INCF	REG4,F
	BTFSS	STATUS,C
	GOTO	CK1_1
	INCF	REG3,F
	BTFSC	REG3,1
	GOTO	CK2
	GOTO	CK1_1

KC1:	CALL	SPI_F		; 
	GOTO	CK0

CK1_1:	INCF	REG4,F		; 1   
	BTFSS	STATUS,Z
	GOTO	CK1_2
	INCF	REG3,F
	BTFSC	REG3,1		;   
	GOTO	CK2
CK1_2:	CALL	SPI_F
	GOTO	CK1_1

CK2:	CALL	SPI_F
	CALL	SPI_F

	MOVF	REG6,W
	MOVWF	REG4
	MOVF	REG5,W	
	MOVWF	REG3
	RETURN






;**************    ****** (REG0,REG1,REG2,REG3)
COMM:	MOVWF	REG3
	CALL	SPI_F

	MOVF	REG3,W
	CALL	SPI	; 

	MOVF	A_H_H,W
	CALL	SPI
	MOVF	A_H_L,W
	CALL	SPI
	MOVF	A_L_H,W
	CALL	SPI
	MOVF	A_L_L,W
	CALL	SPI
	
	CALL	SPI_F	;CRC
	CALL	SPI_F
	CALL	SPI_F	;RESPONSE
	RETURN





;***************  SPI ****(REG0,REG1,REG2)
SPI_FC:	DECF	SEK_C_L,F	;  SPI  
	INCF	SEK_C_L,W
	BTFSC	STATUS,Z
	DECF	SEK_C_H,F

SPI_F:	MOVLW	H'FF'		;  SPI
SPI:	MOVWF	REG1		;  SPI
	MOVLW	D'8'
	MOVWF	REG2
	CLRF	REG0
KL:	NOP
	BCF	PORTB,SCK
	NOP
	BTFSS	REG1,7
	BCF	PORTB,DatI
	BTFSC	REG1,7
	BSF	PORTB,DatI
	RLF	REG1,F
	NOP
	RLF	REG0,F
	BSF	PORTB,SCK
	NOP
	BTFSS	PORTB,DatO
	BCF	REG0,0
	BTFSC	PORTB,DatO
	BSF	REG0,0
	DECFSZ	REG2,F
	GOTO	KL
	MOVF	REG0,W
	RETURN





;*************   *********(REG0-REG3,ADR_FLL,ADR_FLH)
SMB:	MOVWF	ADR_FLL			;   
	CLRF	ADR_FLH
	MOVLW	D'4'
	MOVWF	REG3
	MOVF	ADR_FLL,W
S1:	ADDWF	ADR_FLL,F
	BTFSC	STATUS,C
	INCF	ADR_FLH,F
	DECFSZ	REG3,F
	GOTO	S1

	MOVLW	D'5'			;  
	MOVWF	REG2
	CALL	CON
S2:	CALL	READ_FL			
	MOVWF	REG3
	MOVF	REG3,W
	CALL	LCD_D
	INCF	ADR_FLL,F
	MOVF	ADR_FLL,F
	BTFSC	STATUS,Z
	INCF	ADR_FLH,F
	DECFSZ	REG2,F
	GOTO	S2

	MOVLW	H'00'
	CALL	LCD_D
	CALL	N_CON
	RETURN





;*****************    ************************
N_CON:	BSF	STATUS,RP0	;  1
	BCF	STATUS,RP1
	
	BSF	TRISB,SDTA	;{
	BSF	TRISB,ENAB	; 
	BSF	TRISB,DORC	;
	BCF	TRISB,SCLK	;}

	BCF	STATUS,RP0	;  0
	BCF	PORTB,SCLK	
	RETURN







;****************    ************************* 
CON:	BSF	STATUS,RP0
	BCF	STATUS,RP1

	BCF	TRISB,SDTA	;{
	BCF	TRISB,ENAB	; 
	BCF	TRISB,DORC	;
	BCF	TRISB,SCLK	;}

	BCF	STATUS,RP0

	BSF	PORTB,ENAB
	BSF	PORTB,DORC
	RETURN







;********************    LCD**********(REG0,REG1)
LCD_D:
	BSF	PORTB,DORC
	BCF	PORTB,ENAB
        CALL	BAIT_L
	BSF	PORTB,ENAB
	RETURN







;***************     LCD ******(REG0,REG1)
LCD_C:
	BCF	PORTB,DORC
	BCF	PORTB,ENAB
	CALL	BAIT_L
	BSF	PORTB,ENAB
	BSF	PORTB,DORC
	RETURN




;********************    LCD********(REG0,REG1)
BAIT_L:	
	MOVWF	REG0
	MOVLW	08H      
	MOVWF	REG1
VBIT:	BSF	PORTB,SDTA
	BTFSS	REG0,7
	BCF	PORTB,SDTA
	BCF	PORTB,SCLK
	NOP
	BSF	PORTB,SCLK
	RLF	REG0,1
	DECFSZ	REG1,F
	GOTO	VBIT
	RETURN









;****************   ***********(REG0,REG1,REG2)
LCD_R:
	BCF	PORTB,SDTA
	MOVLW   D'06'
	MOVWF	REG0
CD3:	MOVLW	D'84'
	MOVWF	REG1
CD1:	MOVLW	D'08'  
	MOVWF	REG2
	BSF	PORTB,DORC
	BCF	PORTB,ENAB 
CD2:	BCF	PORTB,SCLK
	NOP
	BSF	PORTB,SCLK
	DECFSZ	REG2,F 
	GOTO	CD2
	BSF	PORTB,ENAB           
	DECFSZ	REG1,F 
	GOTO	CD1             
	DECFSZ	REG0,F    
	GOTO	CD3          
	RETURN







;******************   I2C  *********************** 
;***********   ****** (REG0,REG1)
READ_FL
	BCF	PORTA,SDA		;START
	NOP
	BCF	PORTA,SCL

	MOVLW	B'10100000'		; 
	MOVWF	REG0
	BCF	STATUS,C
	RLF	ADR_FLH,W
	IORWF	REG0,W
	CALL	BAIT

	MOVF	ADR_FLL,W		; 
	CALL	BAIT			;  

	BSF	PORTA,SDA		;RESTART
	NOP
	BSF	PORTA,SCL			
	NOP
	BCF	PORTA,SDA	
	NOP
	BCF	PORTA,SCL

	MOVLW	B'10100001'		; 
	MOVWF	REG0
	BCF	STATUS,C
	RLF	ADR_FLH,W
	IORWF	REG0,W
	CALL	BAIT

	BSF	STATUS,RP0		; 
	BSF	TRISA,SDA
	BCF	STATUS,RP0

	MOVLW	H'08'
	MOVWF	REG1
RID1:	RLF	REG0,F			
	BSF	PORTA,SCL
	NOP
	BTFSC	PORTA,SDA
	BSF	REG0,0		
	BTFSS	PORTA,SDA
	BCF	REG0,0
	BCF	PORTA,SCL
	DECFSZ	REG1,F
	GOTO	RID1

	BSF	STATUS,RP0
	BCF	TRISA,SDA
	BCF	STATUS,RP0
	BCF	PORTA,SDA
	NOP

	BSF	PORTA,SCL			; STOP
	NOP
	BSF	PORTA,SDA

	MOVF	REG0,W
	RETURN




;***************** (REG0,REG1)
BAIT:	MOVWF	REG0
	MOVLW	H'08'			;    
	MOVWF	REG1			; ,   
WR1:	BTFSC	REG0,7			;    SCL
	BSF	PORTA,SDA
	BTFSS	REG0,7
	BCF	PORTA,SDA
	BSF	PORTA,SCL
	NOP
	BCF	PORTA,SCL
	RLF	REG0,F
	DECFSZ	REG1,F
	GOTO	WR1

	BSF	STATUS,RP0		; 
	BSF	TRISA,SDA		; FLASH
	BCF	STATUS,RP0
	BSF	PORTA,SCL
	NOP
	BCF	PORTA,SCL
	BSF	STATUS,RP0		
	BCF	TRISA,SDA		
	BCF	STATUS,RP0	
	RETURN		







;************      EEPROM  *****
READ_EE
	MOVF	ADR_EEP,W
	BSF	STATUS,RP0
	BCF	STATUS,RP1
	MOVWF	EEADR
	BSF	EECON1,RD
	MOVF	EEDATA,W
	BCF	STATUS,RP0
	RETURN



;************    EEPROM   *************
WRITE_EE
	BCF	STATUS,RP1
	BSF	STATUS,RP0
	MOVWF	EEDATA
	BCF	STATUS,RP0
	MOVF	ADR_EEP,W
	BSF	STATUS,RP0
	MOVWF	EEADR
	BSF	EECON1,WREN
	MOVLW	H'55'
	MOVWF	EECON2
	MOVLW	H'AA'
	MOVWF	EECON2
	BSF	EECON1,WR
	BCF	STATUS,RP0
	MOVLW	D'16'		;8 ms
	CALL	PAUSE_M
	RETURN


;*************  ,   (3*(W-1)+8)  ***** (REG0)
PAUSE_MK ;return
	MOVWF	REG0
Z123:	
	DECFSZ	REG0,F
	GOTO	Z123

	RETURN

;*************  ,   ~ W/2  *** (REG0,REG1)
PAUSE_M	;return
	MOVWF	REG1

ZI15:	MOVLW	D'164'
	MOVWF	REG0
ZI13:	DECFSZ	REG0,F
	GOTO	ZI13
	DECFSZ	REG1,F
	GOTO	ZI15
	RETURN




	ORG	H'07B0'
;**************   ********************
TABL
	ADDLW	H'B6'
	MOVWF	TEMP
	MOVLW	D'7'
	MOVWF	PCLATH
	MOVF	TEMP,W
	MOVWF	PCL

;----------

	RETLW	D'69'		;
	RETLW	D'45'		;-
	RETLW	D'66'		;
	RETLW	D'111'		;o
	RETLW	D'111'		;o
	RETLW	D'107'		;k
	RETLW	D'32'		;
	RETLW	D'50'		;2
	RETLW	D'46'		;.
	RETLW	D'48'		;0


;---------- 
	RETLW	D'212'		;
	RETLW	D'224'		;
	RETLW	D'233'		;
	RETLW	D'235'		;
	RETLW	D'251'		;
	RETLW	D'32'		;

	RETLW	D'207'		;
	RETLW	D'229'		;
	RETLW	D'240'		;
	RETLW	D'229'		;
	RETLW	D'233'		;
	RETLW	D'242'		;

	RETLW	D'209'		;
	RETLW	D'238'		;
	RETLW	D'245'		;
	RETLW	D'240'		;
	RETLW	D'224'		;
	RETLW	D'237'		;

	RETLW	D'205'		;
	RETLW	D'224'		;
	RETLW	D'241'		;
	RETLW	D'242'		;
	RETLW	D'240'		;
	RETLW	D'46'		;.

;--------- 1,2
	RETLW	D'199'		;
	RETLW	D'224'		;
	RETLW	D'234'		;
	RETLW	D'49'		;1

	RETLW	D'199'		;
	RETLW	D'224'		;
	RETLW	D'234'		;
	RETLW	D'50'		;2

	RETLW	D'199'		;
	RETLW	D'224'		;
	RETLW	D'234'		;
	RETLW	D'51'		;3

	RETLW	D'207'		;
	RETLW	D'240'		;
	RETLW	D'238'		;
	RETLW	D'246'		;



;------ 3
	RETLW	D'192'		;
	RETLW	D'226'		;
	RETLW	D'242'		;
	RETLW	D'45'		;-
	RETLW	D'239'		;
	RETLW	D'240'		;

	RETLW	D'209'		;
	RETLW	D'234'		;
	RETLW	D'238'		;
	RETLW	D'240'		;
	RETLW	D'45'		;-
	RETLW	D'242'		;

	RETLW	D'200'		;
	RETLW	D'237'		;
	RETLW	D'226'		;
	RETLW	D'229'		;
	RETLW	D'240'		;
	RETLW	D'242'		;

	RETLW	D'206'		;
	RETLW	D'225'		;
	RETLW	D'240'		;
	RETLW	D'225'		;
	RETLW	D'242'		;
	RETLW	D'234'		;
	END







